//-----------------------------------------
// LScript Modeler ImagesToPlanes
//
// Copyright 2013 Michael Green
// mike@mikegreen.name
//

myversion=2;
//2
// Updated to work with 2018 and above. 
//1.9
// Pixels per metre wasn't working, fixed
//1.8
// Added in number of segments in the plane.
//1.7
// Added in using instance values as alphas. Note: the instance values should all be the same, 
// ie all (1) or all (2) not some (1) and some (2)
//1.5
// Added turning alphas to transparency.
//v1.1
// fixed storing of ftype

@version 2.2
@warnings
@script modeler

// global values go here
imagelist;
alphalist;
myimagenumbers;
surflist;
usenumeric=0;
myalpha;
c0;
f10;

main
{
    mydir=recall("Dir",6);
    mytype=recall("Type",3);
    mysize=recall("Size",1.0);
    myheight=recall("Height",1.0);
    mybase=recall("Base",1);
    myalpha=recall("Alpha","_Alpha");
    usenumeric=recall("Numeric",0);
    mysegX=recall("Xsegments",1);
    mysegY=recall("Ysegments",1);

    mycap=recall("Cap",1);
    myfont=recall("Font",1);
    myftype=recall("Ftype",2);
    myfsize=recall("Fsize",1);
    myfheight=recall("Fheight",1);
    myfdepth=recall("Fdepth",1.0);
    myfshift=recall("Fshift",.03);
    myfinset=recall("Finset",.03);
    myfseg=recall("Fseg",1);
    myfsurf=recall("Fsurf","Caption");

	ChangeLists(myalpha);
    
	fontlist[1]="Temp";
    for(i=1;i<=fontcount();i++)
    {
        fontlist[i]=fontname(i);
    }
    i=1;
    surflist[1]="Caption";
    mysurf=Surface();
    while(mysurf)
    {
        surflist[i]=mysurf.name;
        i++;
        mysurf=mysurf.next();
    }

    // requester code goes here

    reqbegin("MGImages to Planes MD Ver"+myversion);
    reqsize(450,min(610,imagelist.size()*16+400));

    tab1= ctltab("Images","Captions");
    c0 = ctllistbox("Images",300,min(270,imagelist.size()*16+30),"listcount","listname");
    b1 = ctlbutton("All Images",150,"SelectAllImages");
    b2 = ctlbutton("Invert Selection",150,"InvertSelection");
    c1 = ctlchoice("Plane direction",mydir,@"-X","-Y","-Z","+X","+Y","+Z"@);
    c2 = ctlchoice("Scaling Type",mytype,@"Fit width","Fit Height","Largest","H & W","Pixels/m"@);
    c3 = ctldistance("Size",mysize);
    c4 = ctldistance("Height",myheight);
    c5 = ctlchoice("Centre",mybase,@"Centre","Base"@);
    c6 = ctlstring("Alpha suffix",myalpha,100);
    c7 = ctlcheckbox("Use Numeric",usenumeric);
    c8 = ctlinteger("X Segments",mysegX);
    c9 = ctlinteger("Y Segments",mysegY);
    t1 = ctltext("Note:","If no image is selected, all will be used");

    f1 = ctlcheckbox("MakeCaptions",mycap);
    ctlposition(f1,81,30);
    f2 = ctlpopup("Font",myfont,fontlist);
    ctlposition(f2,54,55);
    f3 = ctlchoice("Scaling Type",myftype,@"Fit width","Fit Height","Largest","H & W","Pixels/m"@);
    ctlposition(f3,13,80);
    f4 = ctldistance("Font Size",myfsize);
    ctlposition(f4,31,105);
    f5 = ctldistance("Font Height",myfheight);
    ctlposition(f5,20,130);
    f6 = ctldistance("Font Depth",myfdepth);
    ctlposition(f6,22,155);
    f7 = ctlpercent("Bevel Shift",myfshift);
    ctlposition(f7,24,180);
    f8 = ctlpercent("Bevel Inset",myfinset);
    ctlposition(f8,22,205);
    f9 = ctlinteger("Bevel Steps",myfseg);
    ctlposition(f9,18,230);
    f10 = ctlsurface("Surface",myfsurf);
    ctlposition(f10,38,255);
    f11 = ctlpopup("Surface",1,surflist);
    ctlposition(f11,38,280);

    ctlpage(1,c0,b1,b2,c1,c2,c3,c4,c5,c6,t1);
    ctlpage(2,f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f11);

    ctlactive(c2,"SizeType",c4);
    ctlactive(f1,"CapOn",f2,f3,f4,f5,f6,f7,f8,f9,f10,f11);
    ctlrefresh(f11,"ChangeSurf");
    ctlrefresh(c6,"ChangeAndUpdate");
    ctlrefresh(c7,"UseNumericAndUpdate");
//    ctlactive(f3,"SizeType",f5);

    return if !reqpost();
    // get requester control values here
    myimagenumbers=getvalue(c0);
    mydir=getvalue(c1);
    mytype=getvalue(c2);
    mysize=getvalue(c3);
    myheight=getvalue(c4);
    mybase=getvalue(c5);
    myalpha=getvalue(c6);
    usenumeric=getvalue(c7);
    mysegX=getvalue(c8);
    mysegY=getvalue(c9);

    mycap=getvalue(f1);
    myfont=getvalue(f2);
    myftype=getvalue(f3);
    myfsize=getvalue(f4);
    myfheight=getvalue(f5);
    myfdepth=getvalue(f6);
    myfshift=getvalue(f7);
    myfinset=getvalue(f8);
    myfseg=getvalue(f9);
    myfsurf=getvalue(f10);

    reqend();

    store("Dir",mydir);
    store("Type",mytype);
    store("Size",mysize);
    store("Height",myheight);
    store("Base",mybase);
    store("Alpha",myalpha);
    store("Numeric",usenumeric);
    store("Xsegments",mysegX);
    store("Ysegments",mysegY);

    store("Cap",mycap);
    store("Font",myfont);
    store("Ftype",myftype);
    store("Fsize",myfsize);
    store("Fheight",myfheight);
    store("Fdepth",myfdepth);
    store("Fshift",myfshift);
    store("Finset",myfinset);
    store("Fseg",myfseg);
    store("Fsurf",myfsurf);

    if(myimagenumbers==nil)
    {
        myimages=imagelist;
    }
    else
    {
        myimages[1]=nil;
        for(i=1;i<=myimagenumbers.size();i++)
        {
            myimages[i]=imagelist[myimagenumbers[i]];
        }
    }
    
    if(hostVersion()>=9)
        undogroupbegin();

    MakePlanes(myimages,mydir,mytype,mysize,myheight,mybase,
                mycap,myfont,myftype,myfsize,myfheight,myfdepth,myfshift,myfinset,myfseg,myfsurf,myalpha,mysegX,mysegY);

    if(hostVersion()>=9)
        undogroupend();


    info("All done");

}

ChangeLists:val
{
    myalpha=val;
    i=1;
    ia=1;
    imagelist=nil;
    alphalist=nil;
    image=Image();
    while(image)
    {
		imagename=split(image.filename(0));
		if(usenumeric && strright(image.name,myalpha.size())==myalpha)
		{
			alphalist[ia]=image;
			ia++;
		}
		else if(strright(imagename[3],myalpha.size())==myalpha)
		{
			alphalist[ia]=image;
			ia++;
		}
		else
		{
        	imagelist[i]=image;
        	i++;
  		}
        image=image.next();
    }
}

ChangeAndUpdate:val
{
	ChangeLists(val);
	requpdate();
}

UseNumericAndUpdate:val
{
	usenumeric=val;
	ChangeLists(myalpha);
	requpdate();
}


ChangeSurf:val
{
    setvalue(f10,surflist[val]);
}


MakePlanes:pimages,pdir,ptype,psize,pheight,pbase,pcap,
            pfont,pftype,pfsize,pfheight,pfdepth,pfshift,pfinset,pfseg,pfsurf,palpha,psegX,psegY
{

        editbegin();
            myvmap=VMap(VMTEXTURE,"UVL",2);
        editend();

    for(i=1;i<=pimages.size();i++)
    {
        myimage=pimages[i];
        myfilename=split(myimage.filename(0));
        myname=myfilename[3];
        myempty=lyrempty();
        lyrsetfg(myempty[1]);
        setlayername(myname);
        mywidth=myimage.width;
        myheight=myimage.height;
        imagesize=<mywidth,myheight,0>;
        planesize=imagesize/2;
       editbegin();
            for(p=0;p<=psegX;p++)
            {
              for(q=0;q<=psegY;q++)
              {
                mypoints[p+1][q+1]=addpoint(p*mywidth/psegX,q*myheight/psegY,0);
              }
            }
            for(p=1;p<mypoints.size();p++)
            {
              for(q=1;q<mypoints[p].size();q++)
              {
                mypoly=@mypoints[p][q],mypoints[p][q+1],mypoints[p+1][q+1],mypoints[p+1][q]@;
                addpolygon(mypoly,myname);
              }
            }

        editend();
        move(0-planesize);

        if(pbase==2)
            move(<0,planesize.y,0>);
        ScaleObject(ptype,psize,pheight);
        RotateObject(pdir);

        editbegin();
            for(p=1;p<=mypoints.size();p++)
            {
              for(q=1;q<=mypoints[p].size();q++)
              {
                myvmap.setValue(mypoints[p][q],@(p- 1)/psegX,(q- 1)/psegY@);
              }
            }
        editend();


        // Surface options
        mysurface=Surface(myname);
        mysurface.setValue(SURFLUMI,1);
        mysurface.setValue(SURFDIFF,0);
        mymesh=Mesh(0);
        mycommand="Surf_SetSurf \"" + myname + "\" \"" + mymesh.name + "\"";
        CommandInput(mycommand);

        mysurfacefile=WriteSurface(myimage.filename(0));
				CommandInput("Surf_LoadText \""+ mysurfacefile+"\"");

        if(pcap)
        {
            MakeCaption(myname,pfont,pftype,pfsize,pfheight,pfdepth,pfshift,pfinset,pfseg
                        ,pdir,pbase,pfsurf);
        }
    }



}
RotateObject:pdir
{
        switch(pdir)
        {
            case 1:  //-X
                rotate(90,Y);
            break;
            case 2: //-Y
                rotate(90,X);
            break;
            case 3: //-Z
                //nil
            break;
            case 4: //+X
                rotate(-90,Y);
            break;
            case 5: //+Y
                rotate(-90,X);
            break;
            case 6: //+Z
                rotate(180,Y);
            break;
        }
}

MakeCaption:ptext,pfont,pftype,pfsize,pfheight,pfdepth,pfshift,pfinset,pfseg,pdir,pbase,pfsurf
{
    myempty=lyrempty();
        lyrsetfg(myempty[1]);
        setlayername(ptext+" Caption");
        maketext(ptext,pfont,SHARP,0,10);
        copy();
        selmode(USER);
        selpolygon(SET);
        bevel(0,pfdepth);
	    mystring = "";
	    i = 1;
	    while(i <= pfseg)
	    {
		    a = PI / 2 * i / pfseg;
		    mystring2 = string(mystring," ",(1 - cos(a)) * pfinset," ",(sin(a) * pfshift));
		    mystring = mystring2;
		    ++i;
	    }
        shapebevel(mystring);
        paste();
        selpolygon(CLEAR);
        mergepoints();
        alignpols();
        changesurface(pfsurf);

        mylimits=boundingbox();
        mycentre= - 1*(mylimits[1]+mylimits[2])/2;
        if(pbase==1)
            move(mycentre);
        else
            move(<mycentre.x,0,mycentre.z>);

        ScaleObject(pftype,pfsize,pfheight);
        RotateObject(pdir);
}

ScaleObject:ptype,psize,pheight
{
    mybbox=boundingbox();
    mysize=mybbox[2]-mybbox[1];
    switch(ptype)
    {
        case 1: // use width
            myscale=<psize/mysize.x,psize/mysize.x,psize/mysize.x>;
        break;

        case 2: // use height
            myscale=<psize/mysize.y,psize/mysize.y,psize/mysize.y>;
        break;

        case 3: // use largest
            if(mysize.x>mysize.y)
                myscale=<psize/mysize.x,psize/mysize.x,psize/mysize.x>;
            else
                myscale=<psize/mysize.y,psize/mysize.y,psize/mysize.y>;
        break;

        case 4: // use height and width
            myscale=<psize/mysize.x,pheight/mysize.y,pheight/mysize.y>;
        break;
        case 5: // pixels per metre
            myscale=<1/psize,1/psize,1>;
        break;

    }
    scale(myscale);
}

listcount
{
    return(imagelist.size());
}

listname:index
{
    myname=imagelist[index].name;
    return(myname);
}

CapOn:val
{
    return(val);
}

SizeType:value
{
    return(value);
}

SelectAllImages
{
    value[1]=1;
    for(i=1;i<=imagelist.size();i++)
        value[i]=i;
    setvalue(c0,value);
}

InvertSelection
{
    selected=getvalue(c0);
    index=1;
    for(i=1;i<=imagelist.size();i++)
    {
        if(!selected.contains(i))
        {
            value[index]=i;
            index++;
        }
    }
    setvalue(c0,value);
}

WriteSurface:pfilename                       // the image filename for this plane
{
	mycontentdir=getdir("Content");
	pfilename=ReplaceSlashes(pfilename);
	myscript=split(SCRIPTID);
	mysourcefile= myscript[1]+myscript[2]+"MGImagesToPlanes_Surface.txt";    // A saved surface in text format
	mysource=File(mysourcefile,"r");
	mydestfile=mycontentdir+"//imagestoplanes.txt";
	myfile=File(mydestfile,"w");      // The temp surface file to be read back in later
	for (i=1;i<4;i++)
	{
		myline=mysource.read();
		myfile.writeln(myline);
	}

	// Break to write image filename

	myline=mysource.read();               // read the line with dummy filename in
	myfile.writeln("    \""+pfilename+"\"");

	// Start writing 2nd part of surface
	for (i=5;i<439;i++)
	{
		myline=mysource.read();
		myfile.writeln(myline);
	}
	// Break to write image filename

	myline=mysource.read();               // read the line with dummy filename in
	myfile.writeln("                \""+pfilename+"\"");

	// Start writing 3nd part of surface
	for (i=440;i<648;i++)
	{
		myline=mysource.read();
		myfile.writeln(myline);
	}

	mysource.close();
	myfile.close();
	return(mydestfile);
}

ReplaceSlashes:pname
{
	myname=parse("\\",pname);
	mynewname=myname[1];
	for (i=2;i<=myname.size();i++)
	{
		mypart="/"+ myname[i];
		mynewname = mynewname + mypart ;
	}
	return(mynewname);

}
